100 REMark  *************************************************
110 REMark  *     CAPS LOCK INDICATOR AND BEEPER FOR Q68    *
120 REMark  *              BY DILWYN JONES 2023             *
130 REMark  *  (1) uses high/low BEEPs for change of CAPS   *
140 REMark  *  (2) switches Q68 yellow LED on for CAPS on,  *
150 REMark  *      or yellow LED off for CAPS off           *
160 REMark  *  (3) optional key beep on typing upper case   *
170 REMark  *      letters                                  *
180 REMark  *************************************************
190 :
200 REMark set low priority for job
210 IF JOBID <> 0 THEN SPJOB -1, 1
220 :
230 REMark edit the next few lines to customise
240 sound_on%   = 1   : REMark 1=enable BEEPs, 0=disable
250 upper_on%   = 1   : REMark 1=enable BEEP on typing upper case letter
260 yellow_led% = 1   : REMark 1=enable Q68 yellow LED as CAPS indicator
270 kill_key%   = 230 : REMark keycode to kill caps lock job (eg 230=CTR-SH CAPS)
280 :
290 JOB_NAME 'caps'
300 :
310 LET old_caps_state% = -1 : REMark force it to start up
320 previous_key%  = -1 : REMark force it to work on first character
330 :
340 REPeat indicate_caps_state
350   LET new_caps_state% = PEEK(!!136) : REMark Caps Lock system variable
360   IF  new_caps_state% <> old_caps_state%  THEN
370     REMark Caps Lock changed status
380     IF  new_caps_state% = 255 THEN
390       REMark CAPS is now on
400       IF sound_on%   : BEEP 150,0    : REMark high pitched beep for CAPS ON
410       IF yellow_led% : POKE $1C100,1 : REMark turn yellow LED on
420       REMark change CURSPRON job name/number as required
430     ELSE
440       IF sound_on%   : BEEP 750,40   : REMark lower pitched beep for CAPS OFF
450       IF yellow_led% : POKE $1C100,0 : REMark yellow LED off
460     END IF
470     old_caps_state% = new_caps_state%
480   ELSE
490     REMark check last key changed and check for Quit key
500     last_key% = PEEK_W(!!138)
510     IF last_key% <> previous_key% THEN
520       IF last_key% = kill_key% THEN
530        REMark kill capslock program
540         IF sound_on% : BEEP 5000,50
550         EXIT indicate_caps_state
560       END IF
570       IF last_key% > 64 AND last_key% < 91 THEN
580         REMark short medium pitched beep for capital letter typed
590         IF upper_on% = 1 AND sound_on% = 1 : BEEP 100,10
600       END IF
610     END IF
620     previous_key% = last_key%
630   END IF
640 END REPeat indicate_caps_state
650 :
660 IF JOBID <> 0 THEN QUIT
